## libreadline-java 0.7.0

=== Makefile ===
#**************************************************************************
#* Makefile for libJavaReadline.so -- load library for JNI wrapper
#* of GNU readline
#*
#* Copyright (c) 1987-1998 Free Software Foundation, Inc.
#* Java Wrapper Copyright (c) 1998-2001 by Bernhard Bablok (mail@bablokb.de)
#*
#* This program is free software; you can redistribute it and/or modify
#* it under the terms of the GNU Library General Public License as published
#* by  the Free Software Foundation; either version 2 of the License or
#* (at your option) any later version.
#*
#* This program is distributed in the hope that it will be useful, but
#* WITHOUT ANY WARRANTY; without even the implied warranty of
#* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#* GNU Library General Public License for more details.
#*
#* You should have received a copy of the GNU Library General Public License
#* along with this program; see the file COPYING.LIB.  If not, write to
#* the Free Software Foundation Inc., 59 Temple Place - Suite 330,
#* Boston, MA  02111-1307 USA
#***************************************************************************
#
# Toplevel Makefile for Java-Readline
#
# $Author: Bablokb $
# $Revision: 1.10 $
#

TARGET    := java_readline
README    := README README.1st
CHANGELOG := ChangeLog
LICENSE   := COPYING.LIB
TODO      := TODO
NAME      := The Java-Readline Library
HOMEPAGE  := http://www.bablokb.de/java/readline.html
COPYRIGHT := Released under the LGPL, (c) Bernhard Bablok 1998-2001
WTITLE    := "$(NAME)"
DTITLE     = "$(NAME), Version $(VERSION)"
DBOTTOM   := "$(COPYRIGHT)<br>Homepage: <a href="$(HOMEPAGE)">$(HOMEPAGE)</a>"
DHEADER    = "<strong>$(NAME), Version $(VERSION)</strong>"
DFOOTER    = "<strong>$(NAME), Version $(VERSION)</strong>"
PACKROOT  := 
SUBDIRS   := src etc
PACKAGES  := test org.gnu.readline
BIN_ADD    = $(README) $(TODO) $(CHANGELOG) $(LICENSE) \
             $(JAR) $(shell ls *.so) $(APIDIR)
SRC_ADD   := $(README) $(TODO) $(CHANGELOG) $(LICENSE) \
             Makefile VERSION $(SUBDIRS) contrib
MF_STUB   := etc/manifest.stub

# native stuff

export JAVAINCLUDE       := $(JAVA_HOME)/include
export JAVANATINC        := $(JAVA_HOME)/include/linux
export INCLUDES          := -I $(JAVAINCLUDE) -I $(JAVANATINC)
export LIBPATH           := -L/usr/lib/termcap
export T_LIBS            := JavaReadline JavaEditline
export JavaReadline_LIBS := -lreadline -ltermcap -lhistory
export JavaEditline_LIBS := -ledit -ltermcap

VERSION         := $(shell cat VERSION)
export ROOTDIR  := $(shell pwd)
export BUILDDIR := $(shell pwd)/build
export METADIR  := $(BUILDDIR)/META-INF
export CLASSDIR := $(BUILDDIR)
export JAR      := $(TARGET).jar
APIDIR          := ./api

export JAVAC := jikes
export CLASSPATH := $(BUILDDIR):$(JAVA_HOME)/jre/lib/rt.jar
export JAVAC_OPT := -O +E

.PHONY: src-dist bin-dist test apidoc jar subdirs $(SUBDIRS)

jar: subdirs
	$(MAKE) $(JAR)

$(JAR): $(MF_STUB) $(shell find build -type f)
ifeq ($(strip $(MF_STUB)),) 
	jar -cvf $(JAR) -C $(BUILDDIR)/ .
else
	jar -cvfm $(JAR) $(MF_STUB) -C $(BUILDDIR)/ .
endif

apidoc: $(APIDIR)
	javadoc -sourcepath src -d $(APIDIR) -windowtitle $(WTITLE) \
                -doctitle $(DTITLE) -footer $(DFOOTER) -header $(DHEADER) \
                -bottom $(DBOTTOM) \
                -version -author $(patsubst %,$(PACKROOT)%,$(PACKAGES))

bin-dist: jar apidoc
	tar -czf $(TARGET)-$(VERSION)-bin.tgz --exclude "CVS" $(BIN_ADD)
	-rm -fr $(TARGET)-$(VERSION)
	mkdir $(TARGET)-$(VERSION)
	(cd $(TARGET)-$(VERSION); tar -xzf ../$(TARGET)-$(VERSION)-bin.tgz)
	tar -cjf $(TARGET)-$(VERSION)-bin.tar.bz2 $(TARGET)-$(VERSION)
	-rm -fr $(TARGET)-$(VERSION) $(TARGET)-$(VERSION)-bin.tgz 

src-dist: clean
	tar -czf $(TARGET)-$(VERSION)-src.tgz --exclude "CVS" $(SRC_ADD)
	-rm -fr $(TARGET)-$(VERSION)
	mkdir $(TARGET)-$(VERSION)
	(cd $(TARGET)-$(VERSION); tar -xzf ../$(TARGET)-$(VERSION)-src.tgz)
	tar -cjf $(TARGET)-$(VERSION)-src.tar.bz2 $(TARGET)-$(VERSION)
	rm -fr $(TARGET)-$(VERSION) $(TARGET)-$(VERSION)-src.tgz 

subdirs: $(BUILDDIR) $(METADIR) $(SUBDIRS)

$(SUBDIRS):
	$(MAKE) -C $@

$(APIDIR):
	mkdir $(APIDIR)

$(BUILDDIR):
	mkdir $(BUILDDIR)

$(METADIR): 
	mkdir $(METADIR)

test: jar
	LD_LIBRARY_PATH=$(ROOTDIR) java -jar $(JAR) src/test/tinputrc
clean:
	-rm -fr $(JAR) $(TARGET)-*.tar.bz2 $(APIDIR) $(BUILDDIR) .rltest_history
	for dir in $(SUBDIRS); do \
		$(MAKE) -C $$dir clean; \
	done

=== etc/Makefile ===
#**************************************************************************
#* Makefile for libJavaReadline.so -- load library for JNI wrapper
#* of GNU readline
#*
#* Copyright (c) 1987-1998 Free Software Foundation, Inc.
#* Java Wrapper Copyright (c) 1998-2001 by Bernhard Bablok (mail@bablokb.de)
#*
#* This program is free software; you can redistribute it and/or modify
#* it under the terms of the GNU Library General Public License as published
#* by  the Free Software Foundation; either version 2 of the License or
#* (at your option) any later version.
#*
#* This program is distributed in the hope that it will be useful, but
#* WITHOUT ANY WARRANTY; without even the implied warranty of
#* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#* GNU Library General Public License for more details.
#*
#* You should have received a copy of the GNU Library General Public License
#* along with this program; see the file COPYING.LIB.  If not, write to
#* the Free Software Foundation Inc., 59 Temple Place - Suite 330,
#* Boston, MA  02111-1307 USA
#***************************************************************************
#
# $Author: Bablokb $
# $Revision: 1.2 $
#

SUBDIRS := $(shell find . -type d -not -name "." -not -name "CVS" -maxdepth 1)
.PHONY: all clean subdirs $(SUBDIRS)

META-FILES :=
META_TARGETS := $(META-FILES:%=$(METADIR)/%)

all: subdirs $(META_TARGETS)

subdirs: $(SUBDIRS)

$(SUBDIRS):
	-mkdir $(METADIR)/$@
	$(MAKE) -C $@ METADIR=$(METADIR)/$@

$(METADIR)/%: %
	cp -vu $< $(METADIR)

clean:
#	for dir in $(SUBDIRS); do \
#		$(MAKE) -C $$dir clean; \
#	done

=== src/Makefile ===
#**************************************************************************
#* Makefile for libJavaReadline.so -- load library for JNI wrapper
#* of GNU readline
#*
#* Copyright (c) 1987-1998 Free Software Foundation, Inc.
#* Java Wrapper Copyright (c) 1998-2001 by Bernhard Bablok (mail@bablokb.de)
#*
#* This program is free software; you can redistribute it and#or modify
#* it under the terms of the GNU Library General Public License as published
#* by  the Free Software Foundation; either version 2 of the License or
#* (at your option) any later version.
#*
#* This program is distributed in the hope that it will be useful, but
#* WITHOUT ANY WARRANTY; without even the implied warranty of
#* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#* GNU Library General Public License for more details.
#*
#* You should have received a copy of the GNU Library General Public License
#* along with this program; see the file COPYING.LIB.  If not, write to
#* the Free Software Foundation Inc., 59 Temple Place - Suite 330,
#* Boston, MA  02111-1307 USA
#***************************************************************************
#
# $Author: Bablokb $
# $Revision: 1.2 $
#

SUBDIRS := $(shell find . -type d -not -name "." -not -name "CVS" -maxdepth 1)
export SRCROOT := $(shell pwd)

.PHONY: subdirs $(SUBDIRS) clean

subdirs: $(SUBDIRS)

$(SUBDIRS):
	$(MAKE) -C $@

clean:
	for dir in $(SUBDIRS); do \
		$(MAKE) -C $$dir clean; \
	done

=== src/native/Makefile ===
#**************************************************************************
#* Makefile for libJava*.so -- load library for JNI wrapper of
#* of GNU readline
#*
#* Copyright (c) 1987-1998 Free Software Foundation, Inc.
#* Java Wrapper Copyright (c) 1998-2001 by Bernhard Bablok (mail@bablokb.de)
#*
#* This program is free software; you can redistribute it and/or modify
#* it under the terms of the GNU Library General Public License as published
#* by  the Free Software Foundation; either version 2 of the License or
#* (at your option) any later version.
#*
#* This program is distributed in the hope that it will be useful, but
#* WITHOUT ANY WARRANTY; without even the implied warranty of
#* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#* GNU Library General Public License for more details.
#*
#* You should have received a copy of the GNU Library General Public License
#* along with this program; see the file COPYING.LIB.  If not, write to
#* the Free Software Foundation Inc., 59 Temple Place - Suite 330,
#* Boston, MA  02111-1307 USA
#***************************************************************************
#
# Makefile for JNI-library libJava*.so
#
# $Author: Bablokb $
# $Revision: 1.9 $
#

.PHONY: all lib clean

SO := $(patsubst %,$(ROOTDIR)/lib%.so,$(T_LIBS))

all: $(T_LIBS) 

lib: $(ROOTDIR)/lib$(TG).so  

Java%:
	make TG=$@ lib

$(ROOTDIR)/lib%.so: org_gnu_readline_Readline.c org_gnu_readline_Readline.h
	$(CC) $(INCLUDES) $(CPPFLAGS) $(CFLAGS) -D$(TG) \
	-c org_gnu_readline_Readline.c
	gcc -shared $(LIBPATH) $($(TG)_LIBS) org_gnu_readline_Readline.o -o $@

org_gnu_readline_Readline.h: $(BUILDDIR)/org/gnu/readline/Readline.class
	javah -jni org.gnu.readline.Readline
	touch org_gnu_readline_Readline.h

clean:
	-rm -f $(SO) org_gnu_readline_Readline.h org_gnu_readline_Readline.o

=== src/org/Makefile ===
#**************************************************************************
#* Makefile for libJavaReadline.so -- load library for JNI wrapper
#* of GNU readline
#*
#* Copyright (c) 1987-1998 Free Software Foundation, Inc.
#* Java Wrapper Copyright (c) 1998-2001 by Bernhard Bablok (mail@bablokb.de)
#*
#* This program is free software; you can redistribute it and#or modify
#* it under the terms of the GNU Library General Public License as published
#* by  the Free Software Foundation; either version 2 of the License or
#* (at your option) any later version.
#*
#* This program is distributed in the hope that it will be useful, but
#* WITHOUT ANY WARRANTY; without even the implied warranty of
#* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#* GNU Library General Public License for more details.
#*
#* You should have received a copy of the GNU Library General Public License
#* along with this program; see the file COPYING.LIB.  If not, write to
#* the Free Software Foundation Inc., 59 Temple Place - Suite 330,
#* Boston, MA  02111-1307 USA
#***************************************************************************
#
# $Author: Bablokb $
# $Revision: 1.2 $
#

include $(SRCROOT)/mkrules.inc

=== src/org/gnu/Makefile ===
#**************************************************************************
#* Makefile for libJavaReadline.so -- load library for JNI wrapper
#* of GNU readline
#*
#* Copyright (c) 1987-1998 Free Software Foundation, Inc.
#* Java Wrapper Copyright (c) 1998-2001 by Bernhard Bablok (mail@bablokb.de)
#*
#* This program is free software; you can redistribute it and#or modify
#* it under the terms of the GNU Library General Public License as published
#* by  the Free Software Foundation; either version 2 of the License or
#* (at your option) any later version.
#*
#* This program is distributed in the hope that it will be useful, but
#* WITHOUT ANY WARRANTY; without even the implied warranty of
#* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#* GNU Library General Public License for more details.
#*
#* You should have received a copy of the GNU Library General Public License
#* along with this program; see the file COPYING.LIB.  If not, write to
#* the Free Software Foundation Inc., 59 Temple Place - Suite 330,
#* Boston, MA  02111-1307 USA
#***************************************************************************
#
# $Author: Bablokb $
# $Revision: 1.2 $
#

include $(SRCROOT)/mkrules.inc

=== src/org/gnu/readline/Makefile ===
#**************************************************************************
#* Makefile for libJavaReadline.so -- load library for JNI wrapper
#* of GNU readline
#*
#* Copyright (c) 1987-1998 Free Software Foundation, Inc.
#* Java Wrapper Copyright (c) 1998-2001 by Bernhard Bablok (mail@bablokb.de)
#*
#* This program is free software; you can redistribute it and/or modify
#* it under the terms of the GNU Library General Public License as published
#* by  the Free Software Foundation; either version 2 of the License or
#* (at your option) any later version.
#*
#* This program is distributed in the hope that it will be useful, but
#* WITHOUT ANY WARRANTY; without even the implied warranty of
#* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#* GNU Library General Public License for more details.
#*
#* You should have received a copy of the GNU Library General Public License
#* along with this program; see the file COPYING.LIB.  If not, write to
#* the Free Software Foundation Inc., 59 Temple Place - Suite 330,
#* Boston, MA  02111-1307 USA
#***************************************************************************
#
# $Author: Bablokb $
# $Revision: 1.5 $
#

include $(SRCROOT)/mkrules.inc

$(PACKDIR)/Readline.class: $(PACKDIR)/ReadlineLibrary.class

## libreadline-java 0.8.0.1%2Bdfsg

=== debian/changelog ===
libreadline-java (0.8.0.1+dfsg-9) unstable; urgency=medium

  * Team upload.
  * Declare compliance with Debian Policy 4.2.1.
  * Set Breaks and Replaces in debian/control. The documentation is now only
    installed by libreadline-java-doc but was installed by both packages in
    Stretch. (Closes: #898380)

 -- Markus Koschany <apo@debian.org>  Wed, 29 Aug 2018 14:57:45 +0200

libreadline-java (0.8.0.1+dfsg-8) unstable; urgency=medium

  * Team upload.
  * Don't install the NEWS file in libreadline-java-doc (Closes: #898380)
  * Mangle the package version in debian/watch

 -- Emmanuel Bourg <ebourg@apache.org>  Sun, 13 May 2018 01:29:20 +0200

libreadline-java (0.8.0.1+dfsg-7) unstable; urgency=medium

  * Team upload.
  * Replaced javah to fix the build failure with Java 10 (Closes: #897530)
  * Standards-Version updated to 4.1.4
  * Switch to debhelper level 11
  * Use salsa.debian.org Vcs-* URLs
  * Updated the homepage
  * Added a watch file

 -- Emmanuel Bourg <ebourg@apache.org>  Thu, 03 May 2018 00:58:21 +0200

libreadline-java (0.8.0.1+dfsg-6) unstable; urgency=medium

  * Team upload.
  * Switch to compat level 10.
  * Declare compliance with Debian Policy 4.1.1.
  * Build for Java 8. Replace MAKE command with dh_auto_build.
    Thanks to Chris West for the report. (Closes: #873991)
  * Build with --no-parallel to avoid a race condition.

 -- Markus Koschany <apo@debian.org>  Thu, 26 Oct 2017 14:29:58 +0200

libreadline-java (0.8.0.1+dfsg-5) unstable; urgency=medium

  * Address FTBFS with libedit 3.1-20160903-1 (Closes: #844872)
  * Remove Niels Thykier from Uploaders. (Closes: #770584)
    - Thank you for all of your help Niels!
  * Bump Standards-Version to 3.9.8.
  * Freshen debian/copyright.
  * Drop Conflicts/Provides on ancient packages:
    lib-editline-java, lib-readline-java, and libeditline-java

 -- tony mancill <tmancill@debian.org>  Sun, 20 Nov 2016 20:07:32 -0800

libreadline-java (0.8.0.1+dfsg-4) unstable; urgency=medium

  * Correct Vcs URLs.  (Closes: #759619)
  * Add myself to Uploaders.

 -- tony mancill <tmancill@debian.org>  Fri, 29 Aug 2014 08:56:52 -0700

libreadline-java (0.8.0.1+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Apply patch for compilation with clang (Closes: #742220)
    - Thanks to Nicolas Sevelin-Radiguet
  * Drop DMUA flag.
  * Bump Standards-Version to 3.9.5.
  * Add Vcs URLs to debian/control; commit package to pkg-java git repo.
  * Drop needless dependency on JRE.
  * Address build hardening warnings:
    - Depend on DH9.
    - Add makefile patch to honor CFLAGS.
    - Drop hard-coded LDFLAGS in debian/rules

 -- tony mancill <tmancill@debian.org>  Fri, 21 Mar 2014 06:40:38 -0700

libreadline-java (0.8.0.1+dfsg-2) unstable; urgency=low

  * Removed java-virtual-machine from suggests.
  * Stopped debian/rules from assuming that the doc package
    is always built. (Closes: #579291)

 -- Niels Thykier <niels@thykier.net>  Tue, 27 Apr 2010 09:32:07 +0200

libreadline-java (0.8.0.1+dfsg-1) unstable; urgency=low

  * New maintainer. (Closes: #577663)
  * Bumped Standards-Versions to 3.8.4
    - Changed section to java.
    - Added Homepage field.
  * Converted to 3.0 (quilt) source format.
  * Corrected doc-base section (it is now in Programming).
  * Added missing ${misc:Depends}.
  * Correct Build-Depends on libreadline-dev. (Closes: #553800)
  * Added --as-needed to linker flags to avoid linking against unused
    libraries.
  * Updated the README.Debian in libreadline-java and removed the one
    from the -doc package.
  * Made the build use the correct Java during build.
  * Linked the API against the system javadoc.
  * Move install location to api from api-html to comply with the Java
    Policy.
  * Convert build to dh7 and bumped debhelper compat to 7.
  * Updated debian/copyright.
  * Repacked to remove files without license and not from the upstream
    author.

 -- Niels Thykier <niels@thykier.net>  Wed, 21 Apr 2010 23:50:08 +0200

libreadline-java (0.8.0.1-8.2) unstable; urgency=low

  * Non-maintainer upload
  * also include /usr/lib/jvm/default-java/include/linux (closes: #559991)

 -- Rene Engelhard <rene@debian.org>  Fri, 22 Jan 2010 21:46:59 +0100

libreadline-java (0.8.0.1-8.1) unstable; urgency=low

  * Non-maintainer upload.
  * Build-depend on default-jdk-builddep, not building anymore on arm, alpha, hppa.
    Closes: #477885.

 -- Matthias Klose <doko@debian.org>  Sat, 10 May 2008 16:07:57 +0200

libreadline-java (0.8.0.1-8) unstable; urgency=low

  * Change from using gcjh to gjavah, since gcjh has been removed
    (closes: #423992).
  * Switched from setting $DH_COMPAT to using debian/compat instead.
  * Removed blank lines from the end of the doc-base file, which seem to be
    confusing lintian.
  * Bump standards-version to 3.7.2.2 (no changes required).

 -- Ben Burton <bab@debian.org>  Sat, 19 May 2007 15:37:47 +1000

libreadline-java (0.8.0.1-7.1) unstable; urgency=low

  * Non-maintainer upload.
  * Drop Build-Depends on libgcj-dev. (Closes: #359737)

 -- Mohammed Adnène Trojette <adn+deb@diwi.org>  Sat,  5 Aug 2006 20:11:01 +0200

libreadline-java (0.8.0.1-7) unstable; urgency=low

  * Build-depends on java-gcj-compat-dev, so that the recently relocated
    jni.h can be found (closes: #371060).

 -- Ben Burton <bab@debian.org>  Thu,  8 Jun 2006 08:19:38 +1000

libreadline-java (0.8.0.1-6) unstable; urgency=low

  * Rebuilt using gcj-4.1; updated build scripts to reflect the new locations
    of JNI headers, updated build-depends accordingly.
  * Switched to DH_COMPAT=5 and updated build-depends accordingly.
  * Updated standards-version to 3.7.2.0 (no changes required).

 -- Ben Burton <bab@debian.org>  Wed,  7 Jun 2006 07:49:43 +1000

libreadline-java (0.8.0.1-5) unstable; urgency=low

  * Rebuilt against libreadline5 (closes: #326334).  Build-depends on
    libreadline4-dev changed to (libreadline5-dev | libreadline-dev).
  * Bumped standards-version to 3.6.2.1 (no changes required).



## libreadline-java 0.8.0.1+dfsg

=== Makefile ===
#**************************************************************************
#* Makefile for libJavaReadline.so -- load library for JNI wrapper
#* of GNU readline
#*
#* Copyright (c) 1987-1998 Free Software Foundation, Inc.
#* Java Wrapper Copyright (c) 1998-2001 by Bernhard Bablok (mail@bablokb.de)
#*
#* This program is free software; you can redistribute it and/or modify
#* it under the terms of the GNU Library General Public License as published
#* by  the Free Software Foundation; either version 2 of the License or
#* (at your option) any later version.
#*
#* This program is distributed in the hope that it will be useful, but
#* WITHOUT ANY WARRANTY; without even the implied warranty of
#* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#* GNU Library General Public License for more details.
#*
#* You should have received a copy of the GNU Library General Public License
#* along with this program; see the file COPYING.LIB.  If not, write to
#* the Free Software Foundation Inc., 59 Temple Place - Suite 330,
#* Boston, MA  02111-1307 USA
#***************************************************************************
#
# Toplevel Makefile for Java-Readline
#
# $Author: bablokb $
# $Revision: 1.18 $
#

TARGET    = libreadline-java
README    = README README.1st
NEWS      = NEWS
CHANGELOG = ChangeLog
LICENSE   = COPYING.LIB
TODO      = TODO
NAME      = The Java-Readline Library
HOMEPAGE  = http://java-readline.sourceforge.net/
COPYRIGHT = Released under the LGPL, (c) Bernhard Bablok, Henner Zeller 1998-2002
WTITLE    = "$(NAME)"
DTITLE    = "$(NAME), Version $(VERSION)"
DBOTTOM   = "$(COPYRIGHT)<br>Homepage: <a href="$(HOMEPAGE)">$(HOMEPAGE)</a>"
DHEADER   = "<strong>$(NAME), Version $(VERSION)</strong>"
DFOOTER   = "<strong>$(NAME), Version $(VERSION)</strong>"
BIN_ADD   = $(README) $(NEWS) $(TODO) $(CHANGELOG) $(LICENSE) \
             $(JAR) *.so $(APIDIR)
SRC_ADD   = $(README) $(NEWS) $(TODO) $(CHANGELOG) $(LICENSE) \
             Makefile VERSION $(SUBDIRS) contrib src etc
MF_STUB   = etc/manifest.stub

# installation procedure
PREFIX    = /usr
BINLIBDIR = $(PREFIX)/lib
DOCDIR    = $(PREFIX)/doc
JAVALIBDIR= $(PREFIX)/share/java

# libraries to build
T_LIBS    = JavaReadline

# Operating system dependent
JAVAINCLUDE       = $(JAVA_HOME)/include
JAVANATINC        = $(JAVA_HOME)/include/linux

ifeq (MSC,$(WIN32))
JAVA_HOME := c:/j2sdk1.4.0
JAVANATINC = $(JAVA_HOME)/include/win32
export PATH:=/cygdrive/$(subst :,,$(JAVA_HOME))/bin:/cygdrive/c/Programme/DevStudio/VC/bin:/cygdrive/c/Programme/DevStudio/SharedIDE/bin/:$(PATH)
T_LIBS    = JavaGetline
ARGS      = Getline
endif

## normal javac
JAVAC = javac
JC_FLAGS = 

## with jikes
#JAVAC = jikes
#JC_FLAGS = -O +E

VERSION         = `cat VERSION`
JAR             = $(TARGET).jar
APIDIR          = ./api
BUILDDIR        = ./build
# we build the rpm relative to our build..
RPM_BASE        = `pwd`/$(BUILDDIR)/

world : jar build-native

jar: build-java
	cd $(BUILDDIR) ; jar -cvmf ../$(MF_STUB) ../$(JAR) *

$(JAR):
	cd $(BUILDDIR) ; jar -cvmf ../$(MF_STUB) ../$(JAR) *

build-java: $(BUILDDIR)
	cd src ; $(MAKE) JAVAC="$(JAVAC)" JC_FLAGS="$(JC_FLAGS)" java

build-native: 
	cd src; $(MAKE) T_LIBS="$(T_LIBS)" JAVAINCLUDE="$(JAVAINCLUDE)" \
		        JAVANATINC="$(JAVANATINC)" native

apidoc: $(APIDIR)
	javadoc -sourcepath src -d $(APIDIR) -windowtitle $(WTITLE) \
                -doctitle $(DTITLE) -footer $(DFOOTER) -header $(DHEADER) \
                -bottom $(DBOTTOM) \
                -version -author org.gnu.readline test

install: jar build-native apidoc
	install -D $(JAR)    $(DESTDIR)$(JAVALIBDIR)/$(JAR)
	install -d $(DESTDIR)$(BINLIBDIR)
	install  *.so        $(DESTDIR)$(BINLIBDIR)
	install -d $(DESTDIR)$(DOCDIR)/$(TARGET)-$(VERSION)
	cp -r api $(DESTDIR)$(DOCDIR)/$(TARGET)-$(VERSION)

bin-dist: jar build-native apidoc
	mkdir -p "$(TARGET)-$(VERSION)"
	-cp -r $(BIN_ADD) "$(TARGET)-$(VERSION)"
	tar -czf $(TARGET)-$(VERSION)-bin.tar.gz --exclude "CVS" "$(TARGET)-$(VERSION)"
	rm -rf "$(TARGET)-$(VERSION)"

src-dist: clean
	mkdir -p "$(TARGET)-$(VERSION)"
	-cp -r $(SRC_ADD) "$(TARGET)-$(VERSION)"
	tar -czf $(TARGET)-$(VERSION)-src.tar.gz --exclude "CVS" "$(TARGET)-$(VERSION)"
	rm -rf "$(TARGET)-$(VERSION)"

$(APIDIR):
	mkdir $(APIDIR)

$(BUILDDIR):
	mkdir $(BUILDDIR)

$(METADIR): 
	mkdir $(METADIR)

rpm: src-dist
	mkdir -p $(RPM_BASE)/SPECS $(RPM_BASE)/SOURCES $(RPM_BASE)/BUILD \
	      $(RPM_BASE)/SRPMS $(RPM_BASE)/RPMS
	cp etc/libreadline-java.spec $(RPM_BASE)/SPECS
	cp $(TARGET)-$(VERSION)-src.tar.gz $(RPM_BASE)/SOURCES
	rpm --define _topdir$(RPM_BASE) -ba $(RPM_BASE)/SPECS/libreadline-java.spec

test: $(JAR) build-native
	LD_LIBRARY_PATH=. java -jar $(JAR) src/test/tinputrc $(ARGS)

clean:
	$(MAKE) -C src/native clean
	-rm -fr `find . -name "*.o" -o -name "*~"` \
		$(JAR) $(TARGET)-*.tar.*z* $(APIDIR) \
		$(BUILDDIR) *.so .rltest_history

=== src/Makefile ===
#
#

BUILD=../build

all : java native

java: always $(BUILD)
	$(JAVAC) $(JC_FLAGS) -d $(BUILD) `find . -name "*.java"`

native: always
	cd native ; $(MAKE) T_LIBS="$(T_LIBS)" JAVAINCLUDE="$(JAVAINCLUDE)" \
                            JAVANATINC="$(JAVANATINC)" all

$(BUILD):
	mkdir $@

always:

=== src/native/Makefile ===
--- 
+++ 
@@ -23,29 +23,96 @@
 #
 # Makefile for JNI-library libJava*.so
 #
-# $Author: Bablokb $
-# $Revision: 1.9 $
+# $Author: bablokb $
+# $Revision: 1.13 $
 #
 
-.PHONY: all lib clean
+export 
 
-SO := $(patsubst %,$(ROOTDIR)/lib%.so,$(T_LIBS))
+.PHONY: org_gnu_readline_Readline.o
+
+ROOTDIR=../..
+BUILDDIR=$(ROOTDIR)/build
+
+ifeq (MSC,$(WIN32))
+INCLUDES = -I "c:/Programme/DevStudio/VC/include" \
+			-I $(JAVAINCLUDE) -I $(JAVANATINC)
+LIB = "c:/Programme/DevStudio/VC/lib"
+CC = cl
+OBJ_EXT := obj
+LIB_PRE := 
+LIB_EXT := dll
+CFLAGS=-DWIN32=$(WIN32) -D__IBMC__
+else
+INCLUDES          = -I $(JAVAINCLUDE) -I $(JAVANATINC)
+LIBPATH           = -L/usr/lib/termcap 
+JavaReadline_LIBS = -lreadline -ltermcap -lhistory
+JavaEditline_LIBS = -ledit -ltermcap
+ifeq (cygwin,$(WIN32))
+JavaGetline_LIBS = -lcygwin
+endif
+CC = gcc
+OBJ_EXT := o
+LIB_PRE := lib
+LIB_EXT := so
+CFLAGS=-fPIC -DPOSIX
+endif
+
+
+OBJECTS := org_gnu_readline_Readline.$(OBJ_EXT)
+ifeq ($(TG),JavaGetline)
+OBJECTS += getline.$(OBJ_EXT)
+endif
 
 all: $(T_LIBS) 
 
-lib: $(ROOTDIR)/lib$(TG).so  
+lib: $(ROOTDIR)/$(LIB_PRE)$(TG).$(LIB_EXT)
 
-Java%:
+JavaReadline:
 	make TG=$@ lib
 
-$(ROOTDIR)/lib%.so: org_gnu_readline_Readline.c org_gnu_readline_Readline.h
+JavaEditline:
+	make TG=$@ lib
+
+JavaGetline:
+	make TG=$@ lib
+
+$(ROOTDIR)/$(LIB_PRE)$(TG).$(LIB_EXT): $(OBJECTS)
+ifeq (MSC,$(WIN32))
+	$(CC) $(INCLUDES) -LD $(OBJECTS) -Fe$@
+else
+ifeq (CYGWIN,$(WIN32))
+	$(CC) -s -W1,--base-file,$(ROOTDIR)/lib$(TG).base -o $@ \
+		$(OBJECTS) -W1,-e,_readline_init@12
+	dlltool --base-file $(ROOTDIR)/lib$(TG).base \
+		--def $(ROOTDIR)/lib$(TG).def \
+		--output-exp $(ROOTDIR)/lib$(TG).exp \
+		--dllname $(ROOTDIR)/lib$(TG).dll
+	$(CC) -s -W1,--base-file $(ROOTDIR)/lib$(TG).base,$(ROOTDIR)/lib$(TG).exp \
+		-o $@ $(OBJECTS) -W1,-e,_readline_init@12
+	dlltool --base-file $(ROOTDIR)/lib$(TG).base \
+		--def $(ROOTDIR)/lib$(TG).def \
+		--output-exp $(ROOTDIR)/lib$(TG).exp \
+		--dllname $(ROOTDIR)/lib$(TG).dll
+	$(CC) -W1,$(ROOTDIR)/lib$(TG).exp -o $@ \
+		$(OBJECTS) -W1,-e,_readline_init@12
+else
+	$(CC) -shared $(OBJECTS) $(LIBPATH) $($(TG)_LIBS) -o $@
+endif
+endif
+
+getline.$(OBJ_EXT): getline.c
+	$(CC) $(INCLUDES) $(CPPFLAGS) $(CFLAGS) -D$(TG) -c getline.c
+
+org_gnu_readline_Readline.$(OBJ_EXT): org_gnu_readline_Readline.h \
+	                                      org_gnu_readline_Readline.c
 	$(CC) $(INCLUDES) $(CPPFLAGS) $(CFLAGS) -D$(TG) \
-	-c org_gnu_readline_Readline.c
-	gcc -shared $(LIBPATH) $($(TG)_LIBS) org_gnu_readline_Readline.o -o $@
+	                                   -c org_gnu_readline_Readline.c
 
 org_gnu_readline_Readline.h: $(BUILDDIR)/org/gnu/readline/Readline.class
-	javah -jni org.gnu.readline.Readline
+	javah -classpath $(BUILDDIR) -jni org.gnu.readline.Readline
 	touch org_gnu_readline_Readline.h
 
 clean:
-	-rm -f $(SO) org_gnu_readline_Readline.h org_gnu_readline_Readline.o
+	-rm -f org_gnu_readline_Readline.h \
+		org_gnu_readline_Readline.$(OBJ_EXT) getline.$(OBJ_EXT)

=== debian/changelog ===
libreadline-java (0.8.0.1+dfsg-9build1) disco; urgency=medium

  * No-change rebuild for readline soname change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 14 Jan 2019 20:01:28 +0000

=== debian/control ===
Source: libreadline-java
Section: java
Priority: optional
Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders: tony mancill <tmancill@debian.org>
Build-Depends: debhelper (>= 11),
 default-jdk,
 default-jdk-doc,
 libedit-dev (>= 3.1-20160903~),
 libreadline-dev,
 javahelper
Standards-Version: 4.2.1
Vcs-Git: https://salsa.debian.org/java-team/libreadline-java.git
Vcs-Browser: https://salsa.debian.org/java-team/libreadline-java
Homepage: https://github.com/aclemons/java-readline

Package: libreadline-java
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libreadline-java-doc
Description: GNU readline and BSD editline wrappers for Java
 Included is the Java package org.gnu.readline which provides the GNU
 readline and BSD editline libraries for Java.  Note that this is NOT a
 pure Java implementation; it merely contains JNI wrappers for the standard
 system libraries.
 .
 BSD editline resembles GNU readline but is under a more relaxed license.
 In some cases it can be used as a drop-in replacement for GNU readline
 when licensing issues prevent GNU readline from being used.
 .
 The API documentation and examples can be found in libreadline-java-doc.

Package: libreadline-java-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Recommends: w3m | www-browser, default-jdk-doc
Suggests: libreadline-java
Breaks:
 libreadline-java (<< 0.8.0.1+dfsg-7)
Replaces:
 libreadline-java (<< 0.8.0.1+dfsg-7)
Description: API docs for readline/editline wrappers for Java
 This package provides the API documentation and examples for the
 GNU readline and BSD editline wrappers for Java.  The wrappers themselves
 can be found in package libreadline-java.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

egdir = debian/libreadline-java-doc/usr/share/doc/libreadline-java-doc/examples
export JAVA_HOME:=/usr/lib/jvm/default-java

%:
	dh $@ --no-parallel --with javahelper

override_dh_auto_build:
	dh_auto_build -- JAVAC=$(JAVA_HOME)/bin/javac JC_FLAGS="-source 1.8 -target 1.8 -h native" CC=gcc \
	  JAVAINCLUDE=$(JAVA_HOME)/include \
	  JAVANATINC=$(JAVA_HOME)/include \
	  T_LIBS="JavaReadline JavaEditline" jar build-native apidoc

override_dh_auto_install:
	# Skip auto-install - it causes a rebuild and we do not need it.

override_dh_auto_test:
	# Skip tests - they dont work.

override_dh_installexamples:
	dh_installexamples
	# Tidy up the examples directory.
	test ! -d $(egdir) || rm $(egdir)/test/Makefile
	test ! -d $(egdir) || mv $(egdir)/libreadline-java-doc.README.test $(egdir)/README.test

=== debian/watch ===
version=4
opts="repack,compression=xz,uversionmangle=s/_/./g,dversionmangle=s/\+dfsg.*//g" \
https://github.com/aclemons/java-readline/tags .*/archive/(?:v|R_)([\d\._]+).tar.gz
